merge_TATL <- function(TA,TL,category, subcategory,country) {

	if (FALSE) {
		category = "L1"
		subcategory	= "all"
		# merge_TATL(category, subcategory)
		merge_TATL(TA,TL,category, subcategory,country=unique(TA$COUNTRY))
	}

	country_analysis <- country
	cat_filter <- category # "L1"
	subcat_filter <- subcategory # "all"  "A"
	
	cat("########################\n")
	cat("metaDB preparation\n")
	cat("########################\n")
	cat("\n")
	
	#### CHECK TL FIELDS ####
	{
		if ("LITTER_SUB.CATEGORY" %in% colnames(TL)){
			colnames(TL)[which(colnames(TL)=="LITTER_SUB.CATEGORY")] <- "LITTER_SUB-CATEGORY"
		}
		if ("TOTAL_WEIGHT_IN_THE_SUB.CATEGORY_HAUL" %in% colnames(TL)){
			colnames(TL)[which(colnames(TL)=="TOTAL_WEIGHT_IN_THE_SUB.CATEGORY_HAUL")] <- "TOTAL_WEIGHT_IN_THE_SUB-CATEGORY_HAUL"
		}
		if ("TOTAL_NUMBER_IN_THE_SUB.CATEGORY_HAUL" %in% colnames(TL)){
			colnames(TL)[which(colnames(TL)=="TOTAL_NUMBER_IN_THE_SUB.CATEGORY_HAUL")] <- "TOTAL_NUMBER_IN_THE_SUB-CATEGORY_HAUL"
		}
	}
	
	yearsTL <- sort(unique(TL$YEAR))
	TA <- TA[TA$YEAR %in% yearsTL, ]
	
#-------------- COUNTRY
	
	
	TA <- TA[TA$COUNTRY %in% country_analysis & TA$VALIDITY=="V", ]
	TL <- TL[TL$COUNTRY %in% country_analysis , ]
	
	##################
	if (subcat_filter =="all") {
		TL <- TL[TL$LITTER_CATEGORY %in% cat_filter , ]
	} else if (subcat_filter != "all") {
		TL <- TL[TL$LITTER_CATEGORY %in% cat_filter & TL$`LITTER_SUB-CATEGORY` %in% subcat_filter , ]
	}
	##################
	
	source(paste(wd,"scripts/tables_cols.R", sep="/"))
	
	id_TA <- data.frame(id = paste(TA$AREA,TA$COUNTRY,TA$YEAR,"_", TA$VESSEL, TA$MONTH, TA$DAY,"_", TA$HAUL_NUMBER, sep = ""))
	id_TL <- data.frame(id = paste(TL$AREA,TL$COUNTRY,TL$YEAR,"_", TL$VESSEL, TL$MONTH, TL$DAY,"_", TL$HAUL_NUMBER, sep = ""))
	
	colnames(TA)[which(colnames(TA) == "AREA")] <- "GSA"
	colnames(TL)[which(colnames(TL) == "AREA")] <- "GSA"
	TA_merge <- cbind(id_TA,TA)
	TL_merge <- cbind(id_TL,TL)
	
	TL_merge$LITTER_CATEGORY <- as.character(TL_merge$LITTER_CATEGORY)
	TL_merge$"LITTER_SUB-CATEGORY" <- as.character(TL_merge$"LITTER_SUB-CATEGORY")
	
	
	TA_merge <- TA_merge[, which(colnames(TA_merge) %in% TA_cols)]
	TL_merge <- TL_merge[, which(colnames(TL_merge) %in% TL_cols)]
	
	########################
	##    MERGE TA- TL    ##
	########################
	cat("Merging TA-TL files\n")
	
	merge_TATL <- merge(TA_merge, TL_merge, by.x = "id", by.y = "id", all.x = T)
	merge_TATL$CAT_SUBCAT <- as.character(paste(merge_TATL$LITTER_CATEGORY, merge_TATL$`LITTER_SUB-CATEGORY`,sep="_"))
	
	l_TATL <- nrow (merge_TATL)
	i=3
	for (i in 1:l_TATL){
		if (merge_TATL[i, "CAT_SUBCAT"] == "NA_NA")
		{
			merge_TATL[i, "CAT_SUBCAT"              ] <- paste(cat_filter,subcat_filter,sep="_")
			merge_TATL[i, "LITTER_CATEGORY"                       ] <- cat_filter
			merge_TATL[i, "LITTER_SUB-CATEGORY"                   ] <- subcat_filter
			merge_TATL[i, "TOTAL_WEIGHT_IN_THE_CATEGORY_HAUL"     ] <- 0
			merge_TATL[i, "TOTAL_NUMBER_IN_THE_CATEGORY_HAUL"     ] <- 0
			merge_TATL[i, "TOTAL_WEIGHT_IN_THE_SUB-CATEGORY_HAUL" ] <- 0
			merge_TATL[i, "TOTAL_NUMBER_IN_THE_SUB-CATEGORY_HAUL" ] <- 0
		}
	}
	
	Data <- merge_TATL
	source(paste(wd,"scripts/utilities/COORD_Medits - to - WGS84.R", sep="/"))
	coord <- convert_coordinates(merge_TATL)
	
	merge_TATL$MEAN_LATITUDE <- (merge_TATL$SHOOTING_LATITUDE+merge_TATL$HAULING_LATITUDE)/2
	merge_TATL$MEAN_LATITUDE_DEC <- (coord$lat_start+coord$lat_end)/2
	merge_TATL$MEAN_LONGITUDE <- (merge_TATL$SHOOTING_LONGITUDE+merge_TATL$HAULING_LONGITUDE)/2
	merge_TATL$MEAN_LONGITUDE_DEC <- (coord$lon_start+coord$lon_end)/2
	merge_TATL$MEAN_DEPTH <- (merge_TATL$SHOOTING_DEPTH+merge_TATL$HAULING_DEPTH)/2
	merge_TATL$SWEPT_AREA <- merge_TATL$DISTANCE * merge_TATL$WING_OPENING/10000000
	i=1
	hour_shooting <- 0
	min_shooting <- 0
	hour_hauling <- 0
	min_hauling <- 0
	
	strata_scheme <- read.table(paste(wd, "/scripts/utilities/strata.csv", sep=""), sep=";",header = T)
	strata_scheme <- strata_scheme[strata_scheme$GSA == unique(merge_TATL$GSA) & strata_scheme$COUNTRY %in% as.character(unique(merge_TATL$COUNTRY)), ]
	
	i=1
	for (i in 1:l_TATL){
		j=1
		for (j in 1:length(strata_scheme$CODE)){
			if  (merge_TATL$MEAN_DEPTH[i] > strata_scheme[j,4] & merge_TATL$MEAN_DEPTH[i] <= strata_scheme[j,5]) {merge_TATL$STRATUM_CODE[i] <- strata_scheme[j,3]}
		}
		# if  (merge_TATL$MEAN_DEPTH[i] > 10 & merge_TATL$MEAN_DEPTH[i] <= 50) {merge_TATL$STRATUM_CODE[i] <- 1}
		# if  (merge_TATL$MEAN_DEPTH[i] > 50 & merge_TATL$MEAN_DEPTH[i] <= 100) {merge_TATL$STRATUM_CODE[i] <- 2}
		# if  (merge_TATL$MEAN_DEPTH[i] > 100 & merge_TATL$MEAN_DEPTH[i] <= 200) {merge_TATL$STRATUM_CODE[i] <- 3}
		# if  (merge_TATL$MEAN_DEPTH[i] > 200 & merge_TATL$MEAN_DEPTH[i] <= 500) {merge_TATL$STRATUM_CODE[i] <- 4}
		# if  (merge_TATL$MEAN_DEPTH[i] > 500 & merge_TATL$MEAN_DEPTH[i] <= 800) {merge_TATL$STRATUM_CODE[i] <- 5}
		
		if (nchar(merge_TATL$SHOOTING_TIME[i])==4) {hour_shooting[i] <- substr(merge_TATL$SHOOTING_TIME[i],1,2); min_shooting[i] <- substr(merge_TATL$SHOOTING_TIME[i],3,4)} else {
			if (nchar(merge_TATL$SHOOTING_TIME[i])==3) {hour_shooting[i] <- substr(merge_TATL$SHOOTING_TIME[i],1,1); min_shooting[i] <- substr(merge_TATL$SHOOTING_TIME[i],2,3)}}
		
		if (nchar(merge_TATL$HAULING_TIME[i])==4) {hour_hauling[i] <- substr(merge_TATL$HAULING_TIME[i],1,2); min_hauling[i] <- substr(merge_TATL$HAULING_TIME[i],3,4)} else {
			if (nchar(merge_TATL$HAULING_TIME[i])==3) {hour_hauling[i] <- substr(merge_TATL$HAULING_TIME[i],1,1); min_hauling[i] <- substr(merge_TATL$HAULING_TIME[i],2,3)}}
	}
	
	hms_shooting <- hms( rep (0, length(hour_shooting)), as.numeric(min_shooting), as.numeric(hour_shooting))
	hms_hauling  <- hms( rep (0, length(hour_shooting)), as.numeric(min_hauling), as.numeric(hour_hauling))
	duration <-  as.numeric(hms_hauling - hms_shooting)/3600
	
	merge_TATL$SHOOTING_TIME <- hms_shooting
	merge_TATL$HAULING_TIME  <- hms_hauling
	
	merge_TATL$Ncat_h <- merge_TATL$TOTAL_NUMBER_IN_THE_CATEGORY_HAUL/duration
	merge_TATL$Ncat_km2 <- merge_TATL$TOTAL_NUMBER_IN_THE_CATEGORY_HAUL/merge_TATL$SWEPT_AREA
	merge_TATL$kgcat_h <- merge_TATL$TOTAL_WEIGHT_IN_THE_CATEGORY_HAUL/duration/1000
	merge_TATL$kgcat_km2 <- merge_TATL$TOTAL_WEIGHT_IN_THE_CATEGORY_HAUL/merge_TATL$SWEPT_AREA/1000
	
	merge_TATL$Nsubcat_h <- merge_TATL$'TOTAL_NUMBER_IN_THE_SUB-CATEGORY_HAUL'/duration
	merge_TATL$Nsubcat_km2 <- merge_TATL$'TOTAL_NUMBER_IN_THE_SUB-CATEGORY_HAUL'/merge_TATL$SWEPT_AREA
	merge_TATL$kgsubcat_h <- merge_TATL$'TOTAL_WEIGHT_IN_THE_SUB-CATEGORY_HAUL'/duration/1000
	merge_TATL$kgsubcat_km2 <- merge_TATL$'TOTAL_WEIGHT_IN_THE_SUB-CATEGORY_HAUL'/merge_TATL$SWEPT_AREA/1000
	
	merge_TATL$CAT_SUBCAT <- as.character(merge_TATL$CAT_SUBCAT)
	
	write.table(merge_TATL, paste(wd, "/output/Litter/mergeTATL.csv", sep=""), sep=";", row.names=F)
	write.table(merge_TATL, paste(wd, "/output/Litter/mergeTATL_",category,subcategory,".csv", sep=""), sep=";", row.names=F)
	
	cat("TA-TL files correctly merged\n")
	cat(paste("Merge TA-TL files saved in the following folder: '",wd, "/output/mergeTATL.csv\n'","\n", sep=""))
    return(merge_TATL)
}